#include "map.h"
#include <ctype.h>
#include <stdint.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#define MAX_FILE_SIZE 1024 * 16
#define MAX_BUF_LENGTH 1024
#define MAX_COMBO_LENGTH 1024

void load_elements(hashmap *m, char *table) {
  FILE *fptr;

  fptr = fopen(table, "r");

  char *str;

  while (1) {
    str = calloc(MAX_FILE_SIZE, sizeof(char));
    if (!fgets(str, MAX_FILE_SIZE, fptr))
      break;

    char *combo = strstr(str, ";");
    combo[0] = '\0';
    combo++;

    hashmap_set(m, combo, strlen(combo) - 1, (uintptr_t)str);
  }

  // todo: properly free this
}

int fix_delim(char *command, char *needle) {
  char *delim = strstr(command, needle);

  if (!delim)
    return 0;

  delim[0] = ';';

  return 1;
}

int sort_comp(const void *a, const void *b) {
  return strcmp(*(char **)a, *(char **)b);
}

int main(int argc, char *argv[]) {
  hashmap *elements = hashmap_create();
  hashmap *inv = hashmap_create();

  char *command = calloc(MAX_BUF_LENGTH, sizeof(char));
  char *command_re = calloc(MAX_BUF_LENGTH, sizeof(char));
  char **sort_tmp = calloc(MAX_COMBO_LENGTH, sizeof(char **));

  load_elements(elements, "combos.txt");

  while (1) {
    // todo: separate into functions
    fgets(command, MAX_BUF_LENGTH - 1, stdin);

    while (1) {
      int get_out = 0;
      get_out |= fix_delim(command, "+");
      get_out |= fix_delim(command, ",");
      if (!get_out)
        break;
    }
    int cl = strlen(command);

    command[cl - 1] = '\0';

    for (int i = 0; i < cl - 1; i++) {
      command[i] = tolower(command[i]);
    }

    sort_tmp[0] = command;
    int combos = 0;
    for (int i = 1; i < MAX_COMBO_LENGTH; i++) {
      combos = i;
      sort_tmp[i] = strstr(command, ";");
      if (sort_tmp[i] == 0)
        break;
      sort_tmp[i][0] = '\0';
      sort_tmp[i]++;
    }

    qsort(sort_tmp, combos, sizeof(char *), sort_comp);

    char *command_re_tmp = command_re;
    for (int i = 0; i < combos; i++) {
      if (i != 0) {
        command_re_tmp[0] = ';';
        command_re_tmp++;
      }
      char *last = sort_tmp[i];
      strcpy(command_re_tmp, last);
      command_re_tmp += strlen(last);
    }

    uintptr_t result;
    hashmap_get(elements, command_re, strlen(command_re), &result);

    if (result == 0) {
      printf("You didn't make anything.\n");
      continue;
    }
    printf("You made %s!\n", (char *)result);
  }

  // free(command);
}